Dim objArguments
Dim strFunctionName
Dim strArguments
Dim x

Set objArguments = WScript.Arguments

If objArguments.Count > 0 Then

    For x = 0 To objArguments.Count - 1
        If x = 0 Then
            strFunctionName = objArguments(x)
        ElseIf strArguments = "" Then
            strArguments = """" & objArguments(x) & """"
        ElseIf strArguments > "" Then
            strArguments = strArguments & ", " & """" & objArguments(x) & """"
        End If
    Next

    strArguments = Replace(strArguments, Chr(13), "<vbCrLf>", 1, -1, 1) 
    Execute "Call " & strFunctionName & "(" & strArguments & ")"

End If


' Termin in Kalender des angemeldeten Benutzers einfgen.
Private Sub CreateAppointmentItem(ByVal Subject, ByVal Location, ByVal Body, ByVal StartDate, ByVal EndDate, ByVal Duration, ByVal AllDayEvent, ByVal SetReminder, ByVal ReminderMinutesBeforeStart, ByVal Importance, ByVal BusyStatus)

Dim objOutlook
Dim objAppointmentItem
Dim blnAllDayEvent
Dim dtmStartDate
Dim dtmEndDate
Dim lngDuration
Dim blnSetReminder
Dim lngReminderMinutesBeforeStart
Dim lngImportance
Dim lngBusyStatus

Const olAppointmentItem = 1
Const olFree = 0
Const olTentative = 1
Const olBusy = 2
Const olOutOfOffice = 3
Const olImportanceLow = 0
Const olImportanceNormal = 1
Const olImportanceHigh = 2

  ' Objekt-Verweis auf Outlook initialisieren.
    On Error Resume Next
    Set objOutlook = CreateObject("Outlook.Application")
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOkOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Exit Sub
    End If

  ' Neuen Termin erstellen.
    Set objAppointmentItem = objOutlook.CreateItem(olAppointmentItem)
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOkOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Set objAppointmentItem = Nothing
        Exit Sub
    End If	
    On Error Goto 0

  ' Variablen mit Defaults initialisieren.
    dtmStartDate = Now
    dtmEndDate = Now
    lngDuration = 0
    blnAllDayEvent = False
    blnSetReminder = False
    lngReminderMinutesBeforeStart = 0
    lngImportance = olImportanceNormal
    lngBusyStatus = olBusy

  ' Zeilenschaltungen ersetzen.
    Subject = Replace(Subject, "<vbCrLf>", Chr(13) & Chr(10), 1, -1, 1)
    Location = Replace(Location, "<vbCrLf>", Chr(13) & Chr(10), 1, -1, 1)
    Body = Replace(Body, "<vbCrLf>", Chr(13) & chr(10), 1, -1, 1)

  ' Parameter (Strings) in bentigte Datentypen konvertieren.
  ' Startdatum/-zeit.
    If IsDate(StartDate) Then
        dtmStartDate = CDate(StartDate)
    End If

  ' Termindauer.
    If IsNumeric(Duration) Then
        lngDuration = CLng(Duration)
    End If

  ' Enddatum/-zeit
    If IsDate(EndDate) Then
        dtmEndDate = CDate(EndDate)
    Else
      ' Sonst Startdatum + Termindauer.
        dtmEndDate = DateAdd("n", lngDuration, dtmStartDate)
    End If

  ' Falls Enddatum < Startdatum, Enddatum auf Startdatum setzen.
    If dtmEndDate < dtmStartDate Then
        dtmEndDate = dtmStartDate
    End If

  ' Ganztgiger Termin.
    On Error Resume Next
    blnAllDayEvent = CBool(AllDayEvent)
    On Error Goto 0

  ' Bei ganztgigem Termin Startzeit auf 00:00:00 und Endzeit auf 23:59:59 setzen.
    If blnAllDayEvent Then
        dtmStartDate = CDate(FormatDateTime(dtmStartDate, 2))
        dtmEndDate = CDate(FormatDateTime(dtmEndDate, 2))
        dtmEndDate = DateAdd("d", 1, dtmEndDate)
        dtmEndDate = DateAdd("s", -1, dtmEndDate)
    End If

  ' Erinnerung anzeigen.
    On Error Resume Next
    blnSetReminder = CBool(SetReminder)
    On Error Goto 0

  ' Erinnerung Anzahl Minuten vor Terminbeginn.
    If IsNumeric(ReminderMinutesBeforeStart) Then
        lngReminderMinutesBeforeStart = CLng(ReminderMinutesBeforeStart)
    End If

  ' Wichtigkeit des Termins.
    If IsNumeric(Importance) Then
        If (CLng(Importance) >= olImportanceLow) And (CLng(Importance) <= olImportanceHigh) Then
            lngImportance = CLng(Importance)
        End If
    ElseIf Importance <> "" Then
        If LCase(Importance) = "hoch" Or LCase(Importance) = "high" Then
            lngImportance = olImportanceHigh
        ElseIf LCase(Importance) = "normal" Then
            lngImportance = olImportanceNormal
        ElseIf LCase(Importance) = "niedrig" Or LCase(Importance) = "low" Then
            lngImportance = olImportanceLow
        End If
    End If

  ' Frei/Gebucht Informationen
    If IsNumeric(BusyStatus) Then
        If (CLng(BusyStatus) >= olFree) And (CLng(BusyStatus) <= olOutOfOffice) Then
            lngBusyStatus = CLng(BusyStatus)
        End If
    ElseIf BusyStatus <> "" Then
        If LCase(BusyStatus) = "frei" Or LCase(BusyStatus) = "free" Then
            lngBusyStatus = olFree
        ElseIf LCase(BusyStatus) = "mit vorbehalt" Or LCase(BusyStatus) = "tentative" Then
            lngBusyStatus = olTentative
        ElseIf LCase(BusyStatus) = "beschftigt" Or LCase(BusyStatus) = "busy" Then
            lngBusyStatus = olBusy
        ElseIf LCase(BusyStatus) = "abwesend" Or LCase(BusyStatus) = "out of office" Then
            lngBusyStatus = olOutOfOffice
        End If
    End If

  ' Termineigenschaften definieren.
    objAppointmentItem.Subject = Subject
    objAppointmentItem.Location = Location
    objAppointmentItem.Body = Body
    objAppointmentItem.Importance = lngImportance
    objAppointmentItem.Start = dtmStartDate
    objAppointmentItem.End = dtmEndDate
    objAppointmentItem.AllDayEvent = blnAllDayEvent
    If blnSetReminder Then
        objAppointmentItem.ReminderOverrideDefault = True
        objAppointmentItem.ReminderSet = True	
        objAppointmentItem.ReminderMinutesBeforeStart = lngReminderMinutesBeforeStart
    Else
        objAppointmentItem.ReminderSet = False
    End If
    objAppointmentItem.BusyStatus = lngBusyStatus

  ' Termin speichern.
    On Error Resume Next
    objAppointmentItem.Save
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOkOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Set objAppointmentItem = Nothing
        Exit Sub
    End If
    On Error Goto 0

  ' Objekt-Verweise freigeben.
    Set objOutlook = Nothing
    Set objAppointmentItem = Nothing

End Sub


' Termin in freigegebenen Kalender eines Exchange-Benutzers einfgen. 
' Recipient (Benutzer) = In Exchange-Server definierter Alias oder Emailadresse des Benutzers.
Private Sub CreateAppointmentItemInPublicCalendar(ByVal Recipient, ByVal Subject, ByVal Location, ByVal Body, ByVal StartDate, ByVal EndDate, ByVal Duration, ByVal AllDayEvent, ByVal SetReminder, ByVal ReminderMinutesBeforeStart, ByVal Importance, ByVal BusyStatus)

Dim objOutlook
Dim objNameSpace
Dim objRecipient
Dim objAppointmentItem
Dim blnAllDayEvent
Dim dtmStartDate
Dim dtmEndDate
Dim lngDuration
Dim blnSetReminder
Dim lngReminderMinutesBeforeStart
Dim lngImportance
Dim lngBusyStatus

Const olFolderCalendar = 9
Const olAppointmentItem = 1
Const olFree = 0
Const olTentative = 1
Const olBusy = 2
Const olOutOfOffice = 3
Const olImportanceLow = 0
Const olImportanceNormal = 1
Const olImportanceHigh = 2

  ' Objekt-Verweis auf Outlook initialisieren.
    On Error Resume Next
    Set objOutlook = CreateObject("Outlook.Application")
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOKOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Exit Sub
    End If

  ' Objekt-Verweis auf freigegebenen Kalender initialisieren.
    Set objNameSpace = objOutlook.GetNamespace("MAPI")
    Set objRecipient = objNameSpace.CreateRecipient(Recipient)
    objRecipient.Resolve
    If Not objRecipient.Resolved Then
        MsgBox "Empfnger konnte nicht aufgelst werden.", vbInformation + vbOKOnly, "Information"
        Set objOutlook = Nothing
        Set objNameSpace = Nothing
        Set objRecipient = Nothing
        Exit Sub
    End If

  ' Neuen Termin erstellen.
    Set objAppointmentItem = objNameSpace.GetSharedDefaultFolder(objRecipient, olFolderCalendar).Items.Add
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOKOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Set objNameSpace = Nothing
        Set objRecipient = Nothing
        Set objAppointmentItem = Nothing
        Exit Sub
    End If
    On Error GoTo 0

  ' Variablen mit Defaults initialisieren.
    dtmStartDate = Now
    dtmEndDate = Now
    lngDuration = 0
    blnAllDayEvent = False
    blnSetReminder = False
    lngReminderMinutesBeforeStart = 0
    lngImportance = olImportanceNormal
    lngBusyStatus = olBusy

  ' Zeilenschaltungen ersetzen.
    Subject = Replace(Subject, "<vbCrLf>", Chr(13) & Chr(10), 1, -1, 1)
    Location = Replace(Location, "<vbCrLf>", Chr(13) & Chr(10), 1, -1, 1)
    Body = Replace(Body, "<vbCrLf>", Chr(13) & chr(10), 1, -1, 1)

  ' Parameter (Strings) in bentigte Datentypen konvertieren.
  ' Startdatum/-zeit.
    If IsDate(StartDate) Then
        dtmStartDate = CDate(StartDate)
    End If

  ' Termindauer.
    If IsNumeric(Duration) Then
        lngDuration = CLng(Duration)
    End If

  ' Enddatum/-zeit
    If IsDate(EndDate) Then
        dtmEndDate = CDate(EndDate)
    Else
      ' Sonst Startdatum + Termindauer.
        dtmEndDate = DateAdd("n", lngDuration, dtmStartDate)
    End If

  ' Falls Enddatum < Startdatum, Enddatum auf Startdatum setzen.
    If dtmEndDate < dtmStartDate Then
        dtmEndDate = dtmStartDate
    End If

  ' Ganztgiger Termin.
    On Error Resume Next
    blnAllDayEvent = CBool(AllDayEvent)
    On Error GoTo 0

  ' Bei ganztgigem Termin Startzeit auf 00:00:00 und Endzeit auf 23:59:59 setzen.
    If blnAllDayEvent Then
        dtmStartDate = CDate(FormatDateTime(dtmStartDate, 2))
        dtmEndDate = CDate(FormatDateTime(dtmEndDate, 2))
        dtmEndDate = DateAdd("d", 1, dtmEndDate)
        dtmEndDate = DateAdd("s", -1, dtmEndDate)
    End If

  ' Erinnerung anzeigen.
    On Error Resume Next
    blnSetReminder = CBool(SetReminder)
    On Error GoTo 0

  ' Erinnerung Anzahl Minuten vor Terminbeginn.
    If IsNumeric(ReminderMinutesBeforeStart) Then
        lngReminderMinutesBeforeStart = CLng(ReminderMinutesBeforeStart)
    End If

  ' Wichtigkeit des Termins.
    If IsNumeric(Importance) Then
        If (CLng(Importance) >= olImportanceLow) And (CLng(Importance) <= olImportanceHigh) Then
            lngImportance = CLng(Importance)
        End If
    ElseIf Importance <> "" Then
        If LCase(Importance) = "hoch" Or LCase(Importance) = "high" Then
            lngImportance = olImportanceHigh
        ElseIf LCase(Importance) = "normal" Then
            lngImportance = olImportanceNormal
        ElseIf LCase(Importance) = "niedrig" Or LCase(Importance) = "low" Then
            lngImportance = olImportanceLow
        End If
    End If

  ' Frei/Gebucht Informationen
    If IsNumeric(BusyStatus) Then
        If (CLng(BusyStatus) >= olFree) And (CLng(BusyStatus) <= olOutOfOffice) Then
            lngBusyStatus = CLng(BusyStatus)
        End If
    ElseIf BusyStatus <> "" Then
        If LCase(BusyStatus) = "frei" Or LCase(BusyStatus) = "free" Then
            lngBusyStatus = olFree
        ElseIf LCase(BusyStatus) = "mit vorbehalt" Or LCase(BusyStatus) = "tentative" Then
            lngBusyStatus = olTentative
        ElseIf LCase(BusyStatus) = "beschftigt" Or LCase(BusyStatus) = "busy" Then
            lngBusyStatus = olBusy
        ElseIf LCase(BusyStatus) = "abwesend" Or LCase(BusyStatus) = "out of office" Then
            lngBusyStatus = olOutOfOffice
        End If
    End If

  ' Termineigenschaften definieren.
    objAppointmentItem.Subject = Subject
    objAppointmentItem.Location = Location
    objAppointmentItem.Body = Body
    objAppointmentItem.Importance = lngImportance
    objAppointmentItem.Start = dtmStartDate
    objAppointmentItem.End = dtmEndDate
    objAppointmentItem.AllDayEvent = blnAllDayEvent
    If blnSetReminder Then
        objAppointmentItem.ReminderOverrideDefault = True
        objAppointmentItem.ReminderSet = True
        objAppointmentItem.ReminderMinutesBeforeStart = lngReminderMinutesBeforeStart
    Else
        objAppointmentItem.ReminderSet = False
    End If
    objAppointmentItem.BusyStatus = lngBusyStatus

  ' Termin speichern.
    On Error Resume Next
    objAppointmentItem.Save
    If Err.Number <> 0 Then
        MsgBox Err.Description, vbExclamation + vbOKOnly, "Error " & Err.Number
        Set objOutlook = Nothing
        Set objNameSpace = Nothing
        Set objRecipient = Nothing
        Set objAppointmentItem = Nothing
        Exit Sub
    End If
    On Error GoTo 0

  ' Objekt-Verweise freigeben.
    Set objOutlook = Nothing
    Set objNameSpace = Nothing
    Set objRecipient = Nothing
    Set objAppointmentItem = Nothing
    
End Sub
